; ZX81 AY PLAYER
;
; MODIFIED FROM THE SOUNDTRACKER PLAYBACK MODULE
;
; 13/8/2011
;
; ANDY REA
;
#define db .byte ; TASM cross-assembler definitions
#define DB .byte
#define dw .word
#define DW .word
#define ds .block
#define DS .block
#define org .org
#define ORG .org
#define end .end
#define END .end

		ORG 8192

L8000: ;213C84    
		LD      HL,$8000	;START OF SONG DATA
L8003: ;C30980    
		JP      L8009
L8006: ;C34481    
		JP      L8144		;THIS IS THE CALL POINT
						;FOR INTTERUPT DRIVEN
						;SOUND EVERY 1/50TH SECOND
						
L8009: ;F3        
		DI      
L800A: ;7E        
		LD      A,(HL)		;GET DELAY VALUE
L800B: ;327880    
		LD      (L8078),A	;STORE IT
L800E: ;22BB80    
		LD      (SONG_START_SELF_MOD_CODE + 1),HL	;STORE START OF SONG DATA
						; THIS IS SELF MODIFYING CODE
						; AND ALTERS THE BASE ADDRESS ADDED
						; TO THE OFFSET IN THE SUBROUTINE
						; AT L80B5
L8011: ;23        
		INC     HL		;POINT TO NEXT BYTE IN SONG DATA
L8012: ;CDB580    
		CALL    L80B5		;GET A WORD OFFSET - RETURNS POINTER TO
						;ACTUAL BYTE. I.E. START OF SONG + OFFSET
						;ON ENTRY HL = ADRRESS OF LOW BYTE
						;ON EXIT HL = (ENTRY HL+2)
L8015: ;1A        
		LD      A,(DE)		;GET NUMBER OF PATTERNS IN SONG
L8016: ;13        
		INC     DE		;POINT TO NEXT BYTE IN SONG DATA (POSITIONS)
L8017: ;3C        
		INC     A			;NUMBER OF PATTERNS +1 (COUNT FROM 0)
L8018: ;327A80    
		LD      (NUMBER_OF_PATTERNS),A	;SAVE NUMBER OF PATTERNS
L801B: ;ED537080  
		LD      (POINT_POSITIONS_DATA),DE	;SAVE POINTER TO POSITIONS DATA
L801F: ;CDB580    
		CALL    L80B5		;GET A WORD OFFSET
						; SEE L8012 FOR EXPLAINATION
						
L8022: ;ED537280  
		LD      (POINT_COMPILED_ORNAMENTS),DE	;STORE POINTER TO COMPILED ORNAMENTS
	
L8026: ;D5        
		PUSH    DE		;TEMP SAVE THAT POINTER VALUE
L8027: ;CDB580    
		CALL    L80B5		;;GET A WORD OFFSET
						; SEE L8012 FOR EXPLAINATION
						
L802A: ;ED537480  
		LD      (POINT_PATTERNS_DATA),DE	;SAVE POINTER TO PATTERNS DATA
L802E: ;211B00    
		LD      HL,$001B	;OFFSET TO COMPILED SAMPLES
						;THERE IS SOME TEXT IN THE STC FILE
						;THIS SKIPS OVER THE TEXT FIELD
L8031: ;CDBA80    
		CALL    L80BA		;ADDS HL TO THE BASE ADDRESS OF 
						;THE SONG DATA
						;RETURND WITH ADDRESS TO SAMPLE IN DE
						;OLD DE IN HL
L8034: ;EB        
		EX      DE,HL		;SWAP DE AND HL BACK
L8035: ;227680    
		LD      (POINT_SAMPLES_DATA),HL	;SAVE POINTER TO SAMPLES
L8038: ;218180    
		LD      HL,L8081	;??? NOT KNOWN YET
L803C: ;227B80    
		LD      (UNKNOWN_POINTER_1),HL	;??? STORE ABOVE VALUE
L803E: ;218280    
		LD      HL,UNKNOWN_TABLE_1	;START OF TABLE FOR ???
L8041: ;118380    
		LD      DE,L8083	;
L8044: ;012C00    
		LD      BC,$002C	;44 BYTES
L8047: ;70        
		LD      (HL),B		;LOAD $00 INTO FIRST BYTE
L8048: ;EDB0      
		LDIR    			;FILL THE REST
L804A: ;E1        
		POP     HL		;REMEBER THAT POINTER TO COMPILED ORNAMENTS...
L804B: ;012100    
		LD      BC,$0021	;EACH COMPILED ORNAMENT IS 33 BYTES LONG
						;BYTE 1 = ORNAMENT NUMBER
						;NEXT 32 = ORNAMENT DATA
						;POSITIVE NUMBERS = NORMAL
						;NEGATIVE NUMBERS = 1'S COMPLIMENT
L804E: ;AF        
		XOR     A			;ZERO A REGISTER
L804F: ;CDAF80    
		CALL    L80AF		;LOOKS FOR A ZERO AT ORNAMENT NUMBER
						;NOT SURE WHY BECAUSE IF I HAVE READ
						;THE STRUCTURE OF THE STC FILE CORRECTLY
						;THE FIRST ORNAMENT IS ALWAYS ZERO
						
L8052: ;3D        
		DEC     A			;	
L8053: ;328B80    
		LD      (L808B),A	;ENTRY IN CHANNEL 1 PROG DATA
L8056: ;329580    
		LD      (L8095),A	;ENTRY IN CHANNEL 2 PROG DATA
L8059: ;329F80    
		LD      (L809F),A	;ENTRY IN CHANNEL 3 PROG DATA
L805C: ;3E01      
		LD      A,$01		; INITIAL VALUE FOR DELAY COUNT
L805E: ;327980 	
		LD      (DELAY_COUNT),A
L8061: ;23        
		INC     HL		;STILL POINTING TO ORNAMENTS ?
L8062: ;228980    
		LD      (L8089),HL	;ENTRY IN CHANNEL 1 PROG DATA
L8065: ;229380    
		LD      (L8093),HL	;ENTRY IN CHANNEL 2 PROG DATA
L8068: ;229D80    
		LD      (L809D),HL	;ENTRY IN CHANNEL 3 PROG DATA
L806B: ;CD1F84    
		CALL    L841F		;PROG REGISTERS
L806E: ;FB        
		EI      			;INITIALIZZE COMPLETE
L806F: ;C9        
		RET     			;YEAH
		

;L8070: ;77        
;		LD      (HL),A
;L8071: ;F1        
;		POP     AF

L8070:
POINT_POSITIONS_DATA:
		DW	$F177

;L8072: ;8F        
;		ADC     A,A
;L8073: ;F1        
;		POP     AF

L8072:
POINT_COMPILED_ORNAMENTS:
		DW	$F18F
		
;L8074: ;13        
;		INC     DE
;L8075: ;F2

L8074:
POINT_PATTERNS_DATA:
		DW	$F213

L8076: 
POINT_SAMPLES_DATA:
		DW	$EE5E
		
;L8078: ;0601      
;		LD      B,01H		
L8078:
DELAY_VALUE:	
		DB	$06
		
L8079:
DELAY_COUNT:
		DB	$01
		


;L807A: ;0C        
;		INC     C
L807A:
NUMBER_OF_PATTERNS:
		DB	$0C
		
;L807B: ;45        
;		LD      B,L
;L807C: ;E7        
;		RST     20H

L807B:
UNKNOWN_POINTER_1:
PATTERN_DATA_WORD_1_STORE:
CHANNEL_DATA_POINTER_1_STORE:
		DW $E745
		
;L807D: ;8C        
;		ADC     A,H
;L807E: ;67        
;		LD      H,A
;L807F: ;D8        
;		RET     C
;L8080: ;67        
;		LD      H,A

L807D:
PATTERN_DATA_WORD_2_STORE:
CHANNEL_DATA_POINTER_2_STORE:
		DW $678C
		
L807F:
PATTERN_DATA_WORD_3_STORE:
CHANNEL_DATA_POINTER_3_STORE:
		DW $67D8
		
L8081: ;FF        
		RST     38H

UNKNOWN_TABLE_1:
L8082: ;00        
		NOP     
L8083: ;00        
		NOP 
		
CHANNEL_1_PROG_STORE:    
L8084: ;00        
		NOP     
L8085: ;00        
		NOP     
L8086: ;00        
		NOP 
CHANNEL_1_PROG_STORE_PLUS_3    
L8087: ;00        
		NOP     
L8088: ;00        
		NOP     
L8089: ;90        
		SUB     B
L808A: ;F1        
		POP     AF
L808B: ;FF        
		RST     38H
L808C: ;00        
		NOP     
L808D: ;00        
		NOP 
		
CHANNEL_2_PROG_STORE:   
L808E: ;00        
		NOP     
L808F: ;00        
		NOP     
L8090: ;00        
		NOP     
L8091: ;00        
		NOP     
L8092: ;00        
		NOP     
L8093: ;90        
		SUB     B
L8094: ;F1        
		POP     AF
L8095: ;FF        
		RST     38H
L8096: ;00        
		NOP     
L8097: ;00        
		NOP  

CHANNEL_3_PROG_STORE:   
L8098: ;00        
		NOP     
L8099: ;00        
		NOP     
L809A: ;00        
		NOP     
L809B: ;00        
		NOP     
L809C: ;00        
		NOP     
L809D: ;90        
		SUB     B
L809E: ;F1        
		POP     AF
L809F: ;FF        
		RST     38H
L80A0: ;00        
		NOP     
L80A1: ;00        
		NOP 
		
		
OTHER_STORAGE_AREA:	    
L80A2: ;00        
		NOP     
L80A3: ;00        
		NOP     
L80A4: ;00        
		NOP     
L80A5: ;00        
		NOP     
L80A6: ;00        
		NOP     
L80A7: ;00        
		NOP     
L80A8: ;00        
		NOP     
L80A9: ;00        
		NOP     
L80AA: ;00        
		NOP     
L80AB: ;00        
		NOP     
L80AC: ;00        
		NOP     
L80AD: ;00        
		NOP     
L80AE: ;00        
		NOP 
UNKNOWN_TABLE_1_END:		

;==============		    
;=            =
;= SUBROUTINE =
;=            =
;==============

L80AF: ;BE        
		CP      (HL)		;TEST BYTE POINTED TO BY HL WITH A
L80B0: ;C8        
		RET     Z			;RETURN IF EQUAL
L80B1: ;09        
		ADD     HL,BC		;ELSE ADD BC
L80B2: ;C3AF80    
		JP      L80AF		;AND LOOP ROUND
		
;==============		    
;=            =
;= SUBROUTINE =
;=            =
;==============		
		
L80B5: ;5E        
		LD      E,(HL)
L80B6: ;23        
		INC     HL
L80B7: ;56        
		LD      D,(HL)
L80B8: ;23        
		INC     HL
L80B9: ;EB        
		EX      DE,HL
SONG_START_SELF_MOD_CODE:
L80BA: ;010000    
		LD      BC,$0000	;SELF MODIFING CODE !
						;FROM CODE AT $800E
L80BD: ;09        
		ADD     HL,BC
L80BE: ;EB        
		EX      DE,HL
L80BF: ;C9        
		RET 

;==============
;=            =
;= SUBROUTINE =
;=            =
;==============

L80C0: ;1600      
		LD      D,$00
L80C2: ;5F        
		LD      E,A		; DE = A
L80C3: ;87        
		ADD     A,A		; A = A *2
L80C4: ;83        
		ADD     A,E		; A = A * 3
L80C5: ;5F        
		LD      E,A		; E = A * 3
L80C6: ;DD19      
		ADD     IY,DE		; WHAT IS THIS POINTING TO NOW ?
L80C8: ;DD7E01    
		LD      A,(IY+$01)
L80CB: ;CB7F      
		BIT     7,A		; TEST BIT 7
L80CD: ;0E10      
		LD      C,$10		; 
L80CF: ;C2D380    
		JP      NZ,L80D3	;
L80D2: ;4A        
		LD      C,D		;
L80D3: ;CB77      	
		BIT     6,A		;A
L80D5: ;0602      
		LD      B,$02		;
L80D7: ;C2DB80    
		JP      NZ,L80DB
L80DA: ;42        
		LD      B,D
L80DB: ;E61F      
		AND     $1F
L80DD: ;67        
		LD      H,A
L80DE: ;DD5E02    
		LD      E,(IY+$02)
L80E1: ;DD7E00    
		LD      A,(IY+$00)
L80E4: ;F5        
		PUSH    AF
L80E5: ;E6F0      
		AND     $F0
L80E7: ;0F        
		RRCA    
L80E8: ;0F        
		RRCA    
L80E9: ;0F        
		RRCA    
L80EA: ;0F        
		RRCA    
L80EB: ;57        
		LD      D,A
L80EC: ;F1        
		POP     AF
L80ED: ;E60F      
		AND     $0F
L80EF: ;6F        
		LD      L,A
L80F0: ;DDCB016E  
		BIT     5,(IY+$01)
L80F4: ;C8        
		RET     Z
L80F5: ;CBE2      
		SET     4,D
L80F7: ;C9        
		RET   
		
;==============
;=            =
;= SUBROUTINE = 
;=            =
;=====================================
;=                                   =
;= SETS THE NEXT PATTERN TO PLAY ??? =
;=                                   =
;=====================================

L80F8: ;3AA080    
		LD      A,(L80A0)		;??? CURRENT POSITION ?
L80FB: ;4F        
		LD      C,A
L80FC: ;217A80    
		LD      HL,L807A		;POINT TO NUMBER OF PATTERNS
L80FF: ;BE        
		CP      (HL)			;A - (HL) CARRY SET IF (HL) > A
L8100: ;DA0581    
		JP      C,L8105		;JP IF (HL) > A
L8103: ;AF        
		XOR     A				;ZERO A
L8104: ;4F        
		LD      C,A			;ZERO C
L8105: ;3C        
		INC     A				; A = 1 IF NO BRACH ABOVE
							; OR A = A+1 (??? NEXT POSITION) ?
L8106: ;32A080    
		LD      (L80A0),A		; ??? CURRENT POSITION = 1 ?
L8109: ;69        
		LD      L,C			; ??? CURRENT POSITION NUMBER
L810A: ;2600      
		LD      H,$00			; INTO HL
L810C: ;29        
		ADD     HL,HL			; DOUBLE IT (INDEX TO ,2 BYTES PER VALUE, TABLE
L810D: ;ED5B7080  
		LD      DE,(POINT_POSITIONS_DATA)		; GET THE START OF THE TABLE (POSITIONS)
L8111: ;19        
		ADD     HL,DE			;ADD THE INDEX INTO TABLE
L8112: ;4E        
		LD      C,(HL)			;GET THE TABLE VALUE
L8113: ;23        
		INC     HL			;INTO
L8114: ;7E        
		LD      A,(HL)			; C (LOW BYTE [PATTERN TO USE]) AND A (HIGH BYTE)
L8115: ;324483    
		LD      (L8343 + 1),A		;SAVE HIGH BYTE
L8118: ;79        
		LD      A,C			; LOW BYTE INTO A
L8119: ;2A7480    
		LD      HL,(POINT_PATTERNS_DATA)		; GET POINTER TO PATTERNS DATA
L811C: ;010700    
		LD      BC,0007H		; ????
L811F: ;CDAF80    
		CALL    L80AF			;STEP THROUGH PATTERNS DATA UNTIL A MATCH IS FOUND
L8122: ;23        
		INC     HL			;HL POINTS TO NEXT BYTE IN POATTERN DATA
L8123: ;CDB580    
		CALL    L80B5			;GET THE WORD POINTED TO BY HL
L8126: ;ED537B80  
		LD      (L807B),DE		;STORE IT
L812A: ;CDB580    
		CALL    L80B5			;GET THE NEXT WORD
L812D: ;ED537D80  
		LD      (L807D),DE		;STORE IT
L8131: ;CDB580    
		CALL    L80B5			;AND THE LAST WORD
L8134: ;ED537F80  
		LD      (L807F),DE		; AND STORE IT
L8138: ;C9        
		RET 
		
;==============
;=            =
;= SUBROUTINE =
;=            =
;==============
		    
L8139: ;DD3502    
		DEC     (IY+02H)		;DECREMENT
L813C: ;F0        
		RET     P				;RETURN IF STILL POSITIVE
L813D: ;DD7EFF    
		LD      A,(IY-01H)		;ELSE GET RESET VALUE
L8140: ;DD7702    
		LD      (IY+02H),A		;AND RESET IT
L8143: ;C9        
		RET 
		
;==================
;=                =
;= MAIN PLAY LOOP =
;=                =
;=============================
;=                           =
;= CALL EVERY 1/50 TH SECOND =
;=                           =
;=============================
		
PLAY_SOUND:    
L8144: ;3A7980    
		LD      A,(L8079)		;GET CURRENT DELAY COUNT
L8147: ;3D        
		DEC     A				;DECREMENT IT
L8148: ;327980    
		LD      (L8079),A		;AND SAVE NEW VALUE	
L814B: ;C28E82    
		JP      NZ,L828E		;JP IF COUNT <> 0
		
DELAY_COUNTDOWN_REACHED_ZERO:
L814E: ;3A7880    
		LD      A,(L8078)		;GET DELAY VALUE 
L8151: ;327980    
		LD      (L8079),A		;RESTORE DELAY COUNTDOWN
L8154: ;DD218480  
		LD      IY,CHANNEL_1_PROG_STORE		;SET UP INDEX REGISTER FOR CHANNEL 1
							;THIS IS GOING TO BE TROUBLE !
							;POINTS INTO UNKNOWN TABLE 1
L8158: ;CD3981    
		CALL    L8139			;DECREMENTS A VALUE IN UNKNOWN TABLE 1
							;AND RESETS IT WHEN IT PASSES 0
							;READY FOR NEXT DATA ???
							
L815B: ;F26F81    
		JP      P,L816F		;IF STILL POSITIVE (SUB CALLED ABOVE)
							;THEN JUMP (SKIP CHANNEL)

PROCESS_CHANNEL_1:					
L815E: ;2A7B80    
		LD      HL,(CHANNEL_DATA_POINTER_1_STORE)		;ELSE GET THE UNKNOWN POINTER ; POINTS TO CHANNEL DATA ?
L8161: ;7E        
		LD      A,(HL)			;GET THE BYTE POINTED TO
L8162: ;3C        
		INC     A				;INCREMENT IT
L8163: ;CCF880    
		CALL    Z,L80F8		;IF IT'S ROLLED ROUND TO ZERO DO SUB
							;??? SETS NEXT PATTERN TO PLAY ?
L8166: ;2A7B80    
		LD      HL,(CHANNEL_DATA_POINTER_1_STORE)		;GET THE UNKNOWN POINTER ; POINTS TO CHANNEL DATA ?
L8169: ;CD9881    
		CALL    L8198			;PROCESS CHANNEL DATA
L816C: ;227B80    
		LD      (CHANNEL_DATA_POINTER_1_STORE),HL
		
PROCESS_CHANNEL_2:	
L816F: ;DD218E80  
		LD      IY,CHANNEL_2_PROG_STORE		;INDEX FOR CHANNEL 2
L8173: ;CD3981    
		CALL    L8139
L8176: ;F28281    
		JP      P,L8182
L8179: ;2A7D80    
		LD      HL,(CHANNEL_DATA_POINTER_2_STORE)
L817C: ;CD9881    
		CALL    L8198
L817F: ;227D80    
		LD      (CHANNEL_DATA_POINTER_2_STORE),HL
		
PROCESS_CHANNEL_3:
L8182: ;DD219880  
		LD      IY,CHANNEL_3_PROG_STORE		;INDEX FOR CHANNEL 3
L8186: ;CD3981    
		CALL    L8139
L8189: ;F28E82    
		JP      P,L828E
L818C: ;2A7F80    
		LD      HL,(CHANNEL_DATA_POINTER_3_STORE)
L818F: ;CD9881    
		CALL    L8198
L8192: ;227F80    
		LD      (CHANNEL_DATA_POINTER_3_STORE),HL
L8195: ;C38E82    
		JP      L828E			;CHANNEL PROCESSING DONE
		
		
;==============
;=            =
;= SUBROUTINE =
;=            =
;==============
;
; THIS ROUTINE DOES NOT RETURN TO CALLING CODE
; DIRECTLY, BUT RETURNS FROM ONE OF THE 
; SECTIONS OF CODE JUMPED TO
; ACCORDING TO THE DATA BYTE VALUE

L8198: ;7E        
		LD      A,(HL)			;GET A BYTE
L8199: ;FE60      
		CP      $60			;A < $60 ?
L819B: ;DAC681    
		JP      C,L81C6		;A = $0 THRU $5F ~ BITS 0-4 = NOTE IN SEMITONES $00 = C-1
L819E: ;FE70      
		CP      $70			;A => $60 < $70 ?
L81A0: ;DAD381    
		JP      C,L81D3		;A = $60 THRU $6F ~ BITS 0-4 = SAMPLE NUMBER
L81A3: ;FE80      
		CP      $80			;A => $70 < $80 ?
L81A5: ;DAF481    
		JP      C,L81F4		;A = $70 THRU $7F ~ BITS 0-4 = ORNAMENT NUMBER
L81A8: ;CAEB81    
		JP      Z,L81EB		;A = $80 ~ REST (TURN OFF CHANNEL)
L81AB: ;FE81      
		CP      $81			;A = $81 ?
L81AD: ;CAD181    
		JP      Z,L81D1		;A = $81 ~ EMPTY LOCATION ???
L81B0: ;FE82      
		CP      $82			;A = $82
L81B2: ;CAF181    
		JP      Z,L81F1		;A = $82 ~ SELECTS ORNAMENT 0
L81B5: ;FE8F      
		CP      $8F			;A => $83 < $8F
L81B7: ;DA1082    
		JP      C,L8210		;A = $83 < $8E ~ SELECTS EFFECT
L81BA: ;D6A1      
		SUB     $A1			; ELSE SUBRACT 161 FROM A
L81BC: ;DD7702    
		LD      (IY+$02),A		;AND STORE A
L81BF: ;DD77FF    
		LD      (IY-$01),A		;TWICE ?
L81C2: ;23        
		INC     HL			;POINT TO NEXT BYTE
L81C3: ;C39881    
		JP      L8198			;AND LOOP ROUND
		
		
		
;===============
;=             =
;= ROUTINE	=
;=             =
;=================================
;=                               =
;= DEALS WITH SEMITONE NOTE DATA =
;=                               =
;=================================

L81C6: ;DD7701    
		LD      (IY+$01),A		;STORE THE NOTE DATA BYTE
L81C9: ;DD360000  
		LD      (IY+$00),$00	;?
L81CD: ;DD360720  
		LD      (IY+$07),$20	;?
		
;=========
;=
;= THIS POINT IS JUMPED OT FOR AN EMPTY LOCATION
;=
;=========

L81D1: ;23        
		INC     HL			; POINT OT NEXT BYTE
L81D2: ;C9        
		RET     				;DONE
		
;===============
;=             =
;= ROUTINE	=
;=             =
;=================================
;=                               =
;= DEALS WITH SAMPLE NUMBER DATA =
;=                               =
;=================================
		             
L81D3: ;D660      
		SUB     $60			;SUBTRACT $60 TO GET A 0 TO 15 NUMBER
L81D5: ;E5        
		PUSH    HL			; TEMP SAVE CHANNEL DATA POINTER 
L81D6: ;016300    
		LD      BC,$0063		; OFFSET ? VALUE
L81D9: ;2A7680    
		LD      HL,(POINT_SAMPLES_DATA) ; BASE ADDRESS OF SAMPLES DATA
L81DC: ;CDAF80    
		CALL    L80AF			; STEP THROUGH SAMPLES DATA
							; UNTIL SAMPLE NUMBER IS FOUND 
L81DF: ;23        
		INC     HL			;POINT TO FIRST BYTE OF SAMPLE
L81E0: ;DD7503    
		LD      (IY+$03),L		;SAVE THAT ADDRESS
L81E3: ;DD7404    
		LD      (IY+$04),H		;SAVE THAT ADDRESS
L81E6: ;E1        
		POP     HL			;RETRIEVE CHANNEL DATA POINTER
L81E7: ;23        
		INC     HL			;POINT TO NEXT BYTE
L81E8: ;C39881    
		JP      L8198			;LOOP BACK AND DEAL WITH NEXT BYTE
		
;===============
;=             =
;=  ROUTINE	=
;=             =
;=================================
;=                               =
;= TURNS OF CHANNEL              =
;=                               =
;=================================		
		
L81EB: ;23        
		INC     HL			;POINT TO NEXT BYTE IN CHANNEL DATA
L81EC: ;DD3607FF  
		LD      (IY+$07),$FF	; CODE FOR OFF ?
L81F0: ;C9        
		RET  				;DONE
		
		
;===========
;=         =
;= ROUTINE =  
;=         =
;=====================
;=                   =
;= SELECT ORNAMENT 0 =
;=                   =
;=====================

L81F1: ;AF        
		XOR     A			;ZERO
L81F2: ;1802      
		JR      L81F6		;JUMP TO ORNAMENT SELECT ROUTINE, BUT JUMP OVER NORMALIZE SUB
		
;===========
;=         =
;= ROUTINE =  
;=         =
;=====================
;=                   =
;= SELECT ORNAMENT   =
;=                   =
;=====================		
		
L81F4: ;D670      
		SUB     $70 		;SUBTRACT $70 TO GIVE A 0 TO 15 VALUE
		
L81F6: ;E5        
		PUSH    HL		;TEMP SAVE CHANNEL DATA POINTER
L81F7: ;012100    
		LD      BC,$0021	;ORNAMENTS ARE 33 BYTES LONG (1 BYTE, NUMBER + 32 BYTES, DATA)
L81FA: ;2A7280    
		LD      HL,(POINT_COMPILED_ORNAMENTS)  ;ORNAMENTS BASE ADDRESS
L81FD: ;CDAF80    
		CALL    L80AF		;STEP OVER ORNAMENST UNTIL A MATCH IS FOUND
L8200: ;23        
		INC     HL		;POINT TO FIRST BYTE OF ORNAMENT DATA
L8201: ;DD7505    
		LD      (IY+$05),L	; SAVE THAT ADDRESS
L8204: ;DD7406    
		LD      (IY+$06),H	; SAVE THAT ADDRESS
L8207: ;DD36FE00  
		LD      (IY-$02),00	; ??
L820B: ;E1        
		POP     HL		; RETRIEVE THE CHANNEL DATA POINTER
L820C: ;23        
		INC     HL		; POINT TO NEXT BYTE
L820D: ;C39881    
		JP      L8198		; LOOP BACK AND PROCESS NEXT BYTE
		
;===============
;=             =
;= ROUTINE	=
;=             =
;=================================
;=                               =
;= SELECT AN EFFECT              =
;=                               =
;=================================	
		
L8210: ;D680      
		SUB     $80		; SUBTRACT $80
L8212: ;32AE80    
		LD      (L80AE),A	; STORE IN UNKNOWN TABLE
L8215: ;23        
		INC     HL		; POINT TO NEXT BYTE IN CHANNEL DATA
L8216: ;7E        
		LD      A,(HL)		; GET THE BYTE
L8217: ;23        
		INC     HL		; POINT TO NEXT BYTE IN THE CHANNEL DATA
L8218: ;32AC80    
		LD      (L80AC),A	; STORE IT IN UNKNOWN TABLE
L821B: ;DD36FE01  
		LD      (IY-$02),$01
L821F: ;E5        
		PUSH    HL		; TEMP SAVE CHANNEL DATA POINTER
L8220: ;AF        
		XOR     A			; ZERO A
L8221: ;012100    	
		LD      BC,$0021	; 33 BYTES IN EACH ORNAMENT
L8224: ;2A7280    
		LD      HL,(POINT_COMPILED_ORNAMENTS) ;COMPILED ORNAMENTS BASE ADDRESS
L8227: ;CDAF80    
		CALL    L80AF		; STEP OVER EACH ORNAMENT TILL
						; A MATCH IS FOUND
L822A: ;23        
		INC     HL		;POINT TO FIRST BYTE OF ORNAMENT
L822B: ;DD7505    
		LD      (IY+$05),L	; STORE IT
L822E: ;DD7406    
		LD      (IY+$06),H	; STORE IT
L8231: ;E1        
		POP     HL		; RETRIEVE CHANNEL DATA POINTER
L8232: ;C39881    
		JP      L8198		; LOOP BACK AND PROCESS NEXT BYTE
		
		
;==============
;=            =
;= SUBROUTINE =
;=            =
;==============
		
		
L8235: ;DD7E07    
		LD      A,(IY+$07)	; REPEAT COUNT ?
L8238: ;3C        
		INC     A			;TEST IF A WAS = $FF
L8239: ;C8        
		RET     Z			;RETURN IF A = $00
L823A: ;3D        
		DEC     A			;ELSE	
L823B: ;3D        
		DEC     A			; DECREMENT TWICE
L823C: ;DD7707    
		LD      (IY+$07),A	; STORE NEW VALUE A
L823F: ;F5        
		PUSH    AF		; TEMP SAVE A
L8240: ;DD7E00    
		LD      A,(IY+$00)	; GET ?
L8243: ;4F        
		LD      C,A		; PUT IT IN C
L8244: ;3C        
		INC     A			; INCREMENT IT
L8245: ;E61F      
		AND     $1F		;KEEP ONLY LOWEST 5 BITS
L8247: ;DD7700    
		LD      (IY+$00),A	; STORE IT
L824A: ;F1        
		POP     AF		; RETRIEVE PREVIOUS A
L824B: ;C0        
		RET     NZ		; RETURN IF INCREMENT AT L8244 WAS <> 0
L824C: ;DD5E03    
		LD      E,(IY+$03)	; ELSE 
L824F: ;DD5604    
		LD      D,(IY+$04)	; GET A WORD INTO DE ; SAMPLES POINTER ?
L8252: ;216000    
		LD      HL,$0060	; ADD $0060 TO IT ? ; REAPEAT COUNT ?
L8255: ;19        
		ADD     HL,DE
L8256: ;7E        
		LD      A,(HL)		; GET THAT BYTE
L8257: ;3D        
		DEC     A			; DECREMENT IT
L8258: ;FAEC81    
		JP      M,L81EC	; JUMP IF REAPEAT COUNT ROLLS PAST 0
						; TURN OFF CHANNEL ?
L825B: ;4F        
		LD      C,A		; C = A
L825C: ;3C        
		INC     A			; INCREMENT A
L825D: ;E61F      
		AND     $1F		; KEEP LOWEST 5 BITS
L825F: ;DD7700    
		LD      (IY+$00),A	; STORE IT
L8262: ;23        
		INC     HL		;POINT TO REAPEAT COUNT VALUE
L8263: ;7E        
		LD      A,(HL)		; GET IT
L8264: ;3C        
		INC     A			; INC
L8265: ;DD7707    
		LD      (IY+$07),A	; STORE IT
L8268: ;C9        
		RET     
		
;==============
;=            =
;= SUBROUTINE =
;=            =
;==============
	
L8269: ;79        
		LD      A,C
L826A: ;B7        
		OR      A
L826B: ;C0        
		RET     NZ
L826C: ;7C        
		LD      A,H
L826D: ;32A780    
		LD      (L80A7),A
L8270: ;C9        
		RET     
L8271: ;DD7E07    
		LD      A,(IY+$07)
L8274: ;3C        
		INC     A
L8275: ;C8        
		RET     Z
L8276: ;DD7EFE    
		LD      A,(IY-$02)
L8279: ;B7        
		OR      A
L827A: ;C8        
		RET     Z
L827B: ;FE02      
		CP      $02
L827D: ;CA8782    
		JP      Z,L8287
L8280: ;DD36FE02  
		LD      (IY-$02),$02
L8284: ;C38B82    
		JP      L828B
L8287: ;AF        
		XOR     A
L8288: ;32AE80    
		LD      (L80AE),A
L828B: ;CBE6      
		SET     4,(HL)
L828D: ;C9        
		RET   
		
;==============
;=
;= ROUTINE CONTINUES FROM CHANNEL PROCESSOR
;=
;==============

;POST PROCESS CHANNEL 1
L828E: ;DD218480  
		LD      IY,CHANNEL_1_PROG_STORE	; POST PROCCESS CHANNEL 1 
L8292: ;CD3582    
		CALL    L8235					; DO REPEATS ECT ?
									; RETURNS A VALUE IN C ???
L8295: ;79        
		LD      A,C					; REPEATS LEFT ?
L8296: ;323C83    
		LD      (L833B + 1),A				; STORE IT (MAYBE SELF MODIFING CODE AGAIN)
L8299: ;DD2A8780  
		LD      IY,(CHANNEL_1_PROG_STORE_PLUS_3)
L829D: ;CDC080    
		CALL    L80C0					; NOT SURE WHAT THIS DOES
									; SOME JIGGERY POKERY
									; BIT MANIPULATION
L82A0: ;79        
		LD      A,C
L82A1: ;B0        
		OR      B
L82A2: ;0F        
		RRCA    
L82A3: ;32A880    
		LD      (L80A8),A				;STORE IT
L82A6: ;DD218480  
		LD      IY,CHANNEL_1_PROG_STORE
L82AA: ;DD7E07    
		LD      A,(IY+07H)
L82AD: ;3C        
		INC     A
L82AE: ;CABA82    
		JP      Z,L82BA
L82B1: ;CD6982    
		CALL    L8269					;
L82B4: ;CD3283    
		CALL    L8332
L82B7: ;22A180    
		LD      (L80A1),HL
L82BA: ;21A980    
		LD      HL,L80A9
L82BD: ;77        
		LD      (HL),A
L82BE: ;CD7182    
		CALL    L8271
		
;POST PROCESS CHANNEL 2
L82C1: ;DD218E80  
		LD      IY,L808E
L82C5: ;CD3582    
		CALL    L8235
L82C8: ;DD7E07    
		LD      A,(IY+$07)
L82CB: ;3C        
		INC     A
L82CC: ;CAEF82    
		JP      Z,L82EF
L82CF: ;79        
		LD      A,C
L82D0: ;323C83    
		LD      (L833B + 1),A
L82D3: ;DD2A9180  
		LD      IY,(L8091)
L82D7: ;CDC080    
		CALL    L80C0
L82DA: ;3AA880    
		LD      A,(L80A8)
L82DD: ;B1        
		OR      C
L82DE: ;B0        
		OR      B
L82DF: ;32A880    
		LD      (L80A8),A
L82E2: ;CD6982    
		CALL    L8269
L82E5: ;DD218E80  
		LD      IY,L808E
L82E9: ;CD3283    
		CALL    L8332
L82EC: ;22A380    
		LD      (L80A3),HL
L82EF: ;21AA80    
		LD      HL,L80AA
L82F2: ;77        
		LD      (HL),A
L82F3: ;CD7182    
		CALL    L8271
		
;POST PROCESS CHANNEL 3
L82F6: ;DD219880  
		LD      IY,L8098
L82FA: ;CD3582    
		CALL    L8235
L82FD: ;DD7E07    
		LD      A,(IY+$07)
L8300: ;3C        
		INC     A
L8301: ;CA2883    
		JP      Z,L8328
L8304: ;79        
		LD      A,C
L8305: ;323C83    
		LD      (L833B + 1),A
L8308: ;DD2A9B80  
		LD      IY,(L809B)
L830C: ;CDC080    
		CALL    L80C0
L830F: ;3AA880    
		LD      A,(L80A8)
L8312: ;CB01      
		RLC     C
L8314: ;CB00      
		RLC     B
L8316: ;B0        
		OR      B
L8317: ;B1        
		OR      C
L8318: ;32A880    
		LD      (L80A8),A
L831B: ;CD6982    
		CALL    L8269
L831E: ;DD219880  
		LD      IY,L8098
L8322: ;CD3283    
		CALL    L8332
L8325: ;22A580    
		LD      (L80A5),HL
L8328: ;21AB80    
		LD      HL,L80AB
L832B: ;77        
		LD      (HL),A
L832C: ;CD7182    
		CALL    L8271
L832F: ;C31F84    
		JP      L841F			;PROCESSIGN DONE SET THE REGISTERS
		

;==============
;=            =
;= SUBROUTINE =
;=            =
;==============
				
L8332: ;7D        
		LD      A,L
L8333: ;F5        
		PUSH    AF
L8334: ;D5        
		PUSH    DE
L8335: ;DD6E05    
		LD      L,(IY+$05)
L8338: ;DD6606    
		LD      H,(IY+$06)
L833B: ;110500    
		LD      DE,$0005
L833E: ;19        
		ADD     HL,DE
L833F: ;DD7E01    
		LD      A,(IY+$01)
L8342: ;86        
		ADD     A,(HL)
L8343: ;C600      
		ADD     A,$00

L8345: ;87        
		ADD     A,A
L8346: ;5F        
		LD      E,A
L8347: ;1600      
		LD      D,$00
L8349: ;215F83    
		LD      HL,L835F
L834C: ;19        
		ADD     HL,DE
L834D: ;5E        
		LD      E,(HL)
L834E: ;23        
		INC     HL
L834F: ;56        
		LD      D,(HL)
L8350: ;EB        
		EX      DE,HL
L8351: ;D1        
		POP     DE
L8352: ;F1        
		POP     AF
L8353: ;CB62      
		BIT     4,D
L8355: ;2804      
		JR      Z,L835B	;	>>>>>|
L8357: ;CBA2      			;		|
		RES     4,D		;		|
L8359: ;19        			;		|
		ADD     HL,DE		;		|
L835A: ;C9        			;		|
		RET  			;		|
		   				;		|
;===========				;		|
;=         =				;		|
;= ROUTINE =				;		|
;=         =				;		|
;===========				;		|
						;		|
L835B: ;A7        			;		|
		AND     A			;	<<<<<|
L835C: ;ED52      
		SBC     HL,DE
L835E: ;C9        
		RET
		    
L835F: ;F8        
		RET     M
L8360: ;0E10      
		LD      C,$10
L8362: ;0E60      
		LD      C,$60
L8364: ;0D        
		DEC     C
L8365: ;80        
		ADD     A,B
L8366: ;0C        
		INC     C
L8367: ;D8        
		RET     C
L8368: ;0B        
		DEC     BC
L8369: ;280B      
		JR      Z,L8376
L836B: ;88        
		ADC     A,B
L836C: ;0A        
		LD      A,(BC)
L836D: ;F0        
		RET     P
L836E: ;09        
		ADD     HL,BC
L836F: ;60        
		LD      H,B
L8370: ;09        
		ADD     HL,BC
L8371: ;E0        
		RET     PO
L8372: ;08        
		EX      AF,AF'
L8373: ;58        
		LD      E,B
L8374: ;08        
		EX      AF,AF'
L8375: ;E0        
		RET     PO
L8376: ;07        
		RLCA    
L8377: ;7C        
		LD      A,H
L8378: ;07        
		RLCA    
L8379: ;08        
		EX      AF,AF'
L837A: ;07        
		RLCA    
L837B: ;B0        
		OR      B
L837C: ;0640      
		LD      B,$40
L837E: ;06EC      
		LD      B,$EC
L8380: ;05        
		DEC     B
L8381: ;94        
		SUB     H
L8382: ;05        
		DEC     B
L8383: ;44        
		LD      B,H
L8384: ;05        
		DEC     B
L8385: ;F8        
		RET     M
L8386: ;04        
		INC     B
L8387: ;B0        
		OR      B
L8388: ;04        
		INC     B
L8389: ;70        
		LD      (HL),B
L838A: ;04        
		INC     B
L838B: ;2C        
		INC     L
L838C: ;04        
		INC     B
L838D: ;F0        
		RET     P
L838E: ;03        
		INC     BC
L838F: ;BE        
		CP      (HL)
L8390: ;03        
		INC     BC
L8391: ;84        
		ADD     A,H
L8392: ;03        
		INC     BC
L8393: ;58        
		LD      E,B
L8394: ;03        
		INC     BC
L8395: ;2003      
		JR      NZ,L8399+1
L8397: ;F602      
		OR      02H
L8399: ;CA02A2    
		JP      Z,$A202
L839C: ;02        
		LD      (BC),A
L839D: ;7C        
		LD      A,H
L839E: ;02        
		LD      (BC),A
L839F: ;58        
		LD      E,B
L83A0: ;02        
		LD      (BC),A
L83A1: ;3802      
		JR      C,L83A5
L83A3: ;1602      
		LD      D,$02
L83A5: ;F8        
		RET     M
L83A6: ;01DF01    
		LD      BC,$01DF
L83A9: ;C201AC    
		JP      NZ,$AC01
L83AC: ;019001    
		LD      BC,$0190
L83AF: ;7B        
		LD      A,E
L83B0: ;016501    
		LD      BC,$0165
L83B3: ;51        
		LD      D,C
L83B4: ;013E01    
		LD      BC,$013E
L83B7: ;2C        
		INC     L
L83B8: ;011C01    
		LD      BC,$011C
L83BB: ;0B        
		DEC     BC
L83BC: ;01FC00    
		LD      BC,$00FC
L83BF: ;EF        
		RST  28H
L83C0: ;00        
		NOP     
L83C1: ;E1        
		POP     HL
L83C2: ;00        
		NOP     
L83C3: ;D600      
		SUB     $00
L83C5: ;C8        
		RET     Z
L83C6: ;00        
		NOP     
L83C7: ;BD        
		CP      L
L83C8: ;00        
		NOP     
L83C9: ;B2        
		OR      D
L83CA: ;00        
		NOP     
L83CB: ;A8        
		XOR     B
L83CC: ;00        
		NOP     
L83CD: ;9F        
		SBC     A,A
L83CE: ;00        
		NOP     
L83CF: ;96        
		SUB     (HL)
L83D0: ;00        
		NOP     
L83D1: ;8E        
		ADC     A,(HL)
L83D2: ;00        
		NOP     
L83D3: ;85        
		ADD     A,L
L83D4: ;00        
		NOP     
L83D5: ;7E        
		LD      A,(HL)
L83D6: ;00        
		NOP     
L83D7: ;77        
		LD      (HL),A
L83D8: ;00        
		NOP     
L83D9: ;70        
		LD      (HL),B
L83DA: ;00        
		NOP     
L83DB: ;6B        
		LD      L,E
L83DC: ;00        
		NOP     
L83DD: ;64        
		LD      H,H
L83DE: ;00        
		NOP     
L83DF: ;5E        
		LD      E,(HL)
L83E0: ;00        
		NOP     
L83E1: ;59        
		LD      E,C
L83E2: ;00        
		NOP     
L83E3: ;54        
		LD      D,H
L83E4: ;00        
		NOP     
L83E5: ;4F        
		LD      C,A
L83E6: ;00        
		NOP     
L83E7: ;4B        
		LD      C,E
L83E8: ;00        
		NOP     
L83E9: ;47        
		LD      B,A
L83EA: ;00        
		NOP     
L83EB: ;42        
		LD      B,D
L83EC: ;00        
		NOP     
L83ED: ;3F        
		CCF     
L83EE: ;00        
		NOP     
L83EF: ;3B        
		DEC     SP
L83F0: ;00        
		NOP     
L83F1: ;3800      
		JR      C,L83F3
L83F3: ;35        
		DEC     (HL)
L83F4: ;00        
		NOP     
L83F5: ;32002F    
		LD      ($2F00),A
L83F8: ;00        
		NOP     
L83F9: ;2C        
		INC     L
L83FA: ;00        
		NOP     
L83FB: ;2A0027    
		LD      HL,($2700)
L83FE: ;00        
		NOP     
L83FF: ;25        
		DEC     H
L8400: ;00        
		NOP     
L8401: ;23        
		INC     HL
L8402: ;00        
		NOP     
L8403: ;21001F    
		LD      HL,$1F00
L8406: ;00        
		NOP     
L8407: ;1D        
		DEC     E
L8408: ;00        
		NOP     
L8409: ;1C        
		INC     E
L840A: ;00        
		NOP     
L840B: ;1A        
		LD      A,(DE)
L840C: ;00        
		NOP     
L840D: ;19        
		ADD     HL,DE
L840E: ;00        
		NOP     
L840F: ;17        
		RLA     
L8410: ;00        
		NOP     
L8411: ;1600      
		LD      D,$00
L8413: ;15        
		DEC     D
L8414: ;00        
		NOP     
L8415: ;13        
		INC     DE
L8416: ;00        
		NOP     
L8417: ;12        
		LD      (DE),A
L8418: ;00        
		NOP     
L8419: ;110010    
		LD      DE,$1000
L841C: ;00        
		NOP     
L841D: ;0F        
		RRCA    
L841E: ;00        
		NOP  

;==============		
;=            =		
;= SUBROUTINE =
;=            =
;====================
;=                  =
;= SET AY REGISTERS =
;=                  =
;====================		   
L841F: ;21AE80    
		LD      HL,L80AE	; ?
L8422: ;AF        
		XOR     A			;ZERO A
L8423: ;B6        
		OR      (HL)		;TEST BYTE AT $80AE
L8424: ;3E0D      
		LD      A,0DH		;LOAD A WITH 13 
L8426: ;2005      
		JR      NZ,L842D	;IF (HL) <> 0 THEN JUMP FORWARD
L8428: ;D603      
		SUB     03H		;ELSE A = A -3 ($0A)
L842A: ;2B        
		DEC     HL		; ?
L842B: ;2B        
		DEC     HL		; ?
L842C: ;2B        
		DEC     HL		; ? DECREMENT HL BY 3

L842D: ;0EFD      
;		LD      C,$FD		;LOW BYTE PORT ADDRESS (SPECTRUM)
						;REGISTER SELECT
		
		LD	   B,$DF		;HIGH BYTE PORT ADDRESS (ZX81)
						;REGISTER SELECT
AY_WRITE_LOOP:
L842F: ;06FF      
;		LD      B,$FF		;HIGH BYTE PORT ADDRESS (SPECTRUM)
						;REGISTER SELECT
						
		LD	   C,$DF		;LOW BYTE PORT ADDRESS (ZX81)
						;REGISTER SELECT
						;NEEDED TO SWAP ORDER AS ITS INSIDE A LOOP
L8431: ;ED79      
		OUT     (C),A		;SELECT THE REGISTER TO WRITE TO
L8433: ;06BF      
;		LD      B,$BF		;HIGH BYTE PORT ADDRESS (SPECTRUM)
						;DATA PORT
						
		LD	   C,$1F		;LOW BYTE PORT ADREESS (ZX81)
		
L8435: ;EDAB      
		OUTD    			;OUTPUT (HL) TO PORT (BC)
						;AND DECREMENT HL
L8437: ;3D        
		DEC     A			;DECREMENT REGISTER SELECTOR
L8438: ;F22F84    
		JP      P,L842F	;IF NOT MINUS GO ROUND AGAIN
L843B: ;C9        
		RET     			;DONE FOR NOW

		

	.END